> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://typeform.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://typeform.ferndocs.com/_mcp/server.

# Update custom messages

PUT https://api.typeform.com/forms/{form_id}/messages
Content-Type: application/json

Specifies new values for the customizable messages in a form (specified by `form_id`).

You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.

Reference: https://typeform.ferndocs.com/documentation/create-api/api-reference/forms/set-messages

## Authentication

- `Authorization` header (bearer token, required) — Bearer token authentication. Tokens can be generated from the user account. Privileges needed may vary.
- `Authorization` header (required) — A string representation of JWT containing at least two parameters: `ctx.user_id` — user's id `ctx.account_id` — user's default account id `ctx.account_uid` — user's default account uid The usage of account_(u)id from JWT is discouraged, user can have access to multiple accounts, every endpoint has to be account aware if it's needed. This JWT must be signed by the appropriate authority.

## Request

### Path parameters

- `form_id` (any, required) — Unique ID for the form. Find in your form URL. For example, in the URL "https://mysite.typeform.com/to/u6nXL7" the form_id is `u6nXL7`.

### Body (application/json)

This endpoint expects an object.

- `label.buttonHint.default` (string, optional) — Default tooltip button message. Maximum 28 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.buttonHint.longtext` (string, optional) — Tooltip button message for long text blocks. Maximum 28 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.warning.connection` (string, optional) — Server connection error message. Maximum 128 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.buttonNoAnswer.default` (string, optional) — Default continue button message. Maximum 100 characters.
- `label.warning.correction` (string, optional) — List of errors message. Maximum 128 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.payment.cardNameTitle` (string, optional) — Credit card name message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.payment.cardNumberTitle` (string, optional) — Credit card number message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.payment.cvcDescription` (string, optional) — Credit card security number message
- `block.payment.cvcNumberTitle` (string, optional) — Credit card CVC number message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.shortText.placeholder` (string, optional) — Text input placeholder. Maximum 100 characters.
- `label.error.emailAddress` (string, optional) — Invalid email error message. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.expiryMonthTitle` (string, optional) — Credit card expiry month message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.expiryYearTitle` (string, optional) — Credit card expiry year message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.warning.fallbackAlert` (string, optional) — Fallback alert message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.fileUpload.choose` (string, optional) — File upload button message. Maximum 34 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.fileUpload.drag` (string, optional) — File upload dragging action message. Maximum 35 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.fileUpload.uploadingProgress` (string, optional) — Still processing file upload message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.sizeLimit` (string, optional) — File too big error message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.warning.formUnavailable` (string, optional) — Private form error message. Accepts variable `form:name`. Maximum 128 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.incompleteForm` (string, optional) — Incomplete fields error message. Maximum 42 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.hint.key` (string, optional) — Key letter hint message. Maximum 100 characters.
- `block.legal.reject` (string, optional) — Legal field deny message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.legal.accept` (string, optional) — Legal field accept message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.maxValue` (string, optional) — Number maximum value tooltip message. Accepts variable `field:max`. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.maxLength` (string, optional) — Text fields maximum length tooltip message. Accepts variable `field:max_length`. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.minValue` (string, optional) — Number minimum value tooltip message. Accepts variable `field:min`. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.range` (string, optional) — Number minimum and maximum range value tooltip message. Accepts variables `field:min` and `field:max`. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.multipleChoice.hint` (string, optional) — Choose as many as you like message for multiple choice fields. Maximum 45 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.mustEnter` (string, optional) — Required value error message. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.mustSelect` (string, optional) — Required selection error message. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.no.shortcut` (string, optional) — Keyboard shortcut for the "No" option. Maximum 1 character.
- `label.no.default` (string, optional) — Representation for the word "No." You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.dropdown.hint` (string, optional) — Not suggestions found for dropdown fields error message. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.multipleChoice.other` (string, optional) — Other answer message. Maximum 100 characters.
- `label.progress.percent` (string, optional) — Completion percentage message. Accepts variable `progress:percent`. Maximum 100 characters.
- `label.progress.proportion` (string, optional) — Completion proportion message. Accepts variables `progress:step` and `progress:total`. Maximum 100 characters.
- `label.error.required` (string, optional) — Required field error message. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.preview` (string, optional) — Review fields error message. Accepts variable `form:unanswered_fields`. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.button.review` (string, optional) — Review button message. Maximum 100 characters.
- `label.error.server` (string, optional) — Server error message. Maximum 128 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.action.share` (string, optional) — Share text message. Maximum 100 characters.
- `label.button.submit` (string, optional) — Submit button message. Maximum 100 characters.
- `label.warning.success` (string, optional) — Successful submit message. Maximum 128 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.button.ok` (string, optional) — Answer confirm. Maximum 100 characters.
- `label.error.mustAccept` (string, optional) — Legal field terms and conditions message. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.longtext.hint` (string, optional) — Long text field tooltip message. Maximum 128 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.dropdown.placeholder` (string, optional) — Placeholder message with instructions for dropdown fields. Maximum 100 characters.
- `block.dropdown.placeholderTouch` (string, optional) — Placeholder message with instructions for dropdown fields on touch devices. Maximum 100 characters.
- `label.error.url` (string, optional) — Invalid URL error message. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.yes.shortcut` (string, optional) — Keyboard shortcut for the "Yes" option. Maximum 1 character.
- `label.yes.default` (string, optional) — Representation for the word "Yes". You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.

## Response

### 204

OK

## Examples

**Request**

```json
{}
```

**Response**

```json
{}
```

**SDK Code**

```python
import requests

url = "https://api.typeform.com/forms/:form_id/messages"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.typeform.com/forms/:form_id/messages';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.typeform.com/forms/:form_id/messages"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.typeform.com/forms/:form_id/messages")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.typeform.com/forms/:form_id/messages")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.typeform.com/forms/:form_id/messages', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.typeform.com/forms/:form_id/messages");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.typeform.com/forms/:form_id/messages")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```